#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 1e5;

int a[N], bl[N], br[N], pref_sm[N + 1], ml[N], mr[N], tree_mx[4 * N];

int ph[4 * N];
pair<int, int> tree[4 * N];

void init(int n, int l, int r) {
    if (r - l == 1) {
        tree[n] = {r, r};
        tree_mx[n] = a[l];
        return;
    }

    int m = (l + r) / 2;
    init(2 * n + 1, l, m);
    init(2 * n + 2, m, r);

    tree[n] = {l + 1, r};
    tree_mx[n] = max(tree_mx[2 * n + 1], tree_mx[2 * n + 2]);
}

void push(int n, int l, int r) {
    tree[n].first += ph[n];
    tree[n].second += ph[n];

    if (r - l > 1) {
        ph[2 * n + 1] += ph[n];
        ph[2 * n + 2] += ph[n];
    }

    ph[n] = 0;
}

int query(int n, int l, int r, int val, bool flag) {
    push(n, l, r);

    if (r - l == 1) return l;

    int m = (l + r) / 2;

    push(2 * n + 1, l, m);
    push(2 * n + 2, m, r);

    if (flag) {
        if (tree[2 * n + 1].first <= val && val <= tree[2 * n + 1].second) {
            return query(2 * n + 1, l, m, val, flag);
        }
        return query(2 * n + 2, m, r, val, flag);
    }

    if (tree[2 * n + 2].first <= val && val <= tree[2 * n + 2].second) {
        return query(2 * n + 2, m, r, val, flag);
    }

    return query(2 * n + 1, l, m, val, flag);
}

void update(int n, int l, int r, int ql, int qr) {
    push(n, l, r);

    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        ph[n]--;
        push(n, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(2 * n + 1, l, m, ql, qr);
    update(2 * n + 2, m, r, ql, qr);

    tree[n].first = min(tree[2 * n + 1].first, tree[2 * n + 2].first);
    tree[n].second = max(tree[2 * n + 1].second, tree[2 * n + 2].second);
}

int query_mx(int n, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return 0;
    if (ql <= l && r <= qr) return tree_mx[n];

    int m = (l + r) / 2;
    return max(query_mx(2 * n + 1, l, m, ql, qr), query_mx(2 * n + 2, m, r, ql, qr));
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    unordered_set<int> s;
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; s.insert(a[i]);
        bl[i] = -1, br[i] = n;

        pref_sm[i + 1] = pref_sm[i] + a[i];

        ml[i] = mr[i] = a[i];
    }

    vector<int> q;
    for (int i = 0; i < n; ++i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            br[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    q.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            bl[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    init(0, 0, n);

    for (int t = 1; t < n; ++t) {
        int k; cin >> k;

        int ql = query(0, 0, n, k, true), qm = query(0, 0, n, k, false);

        update(0, 0, n, qm + 1, n);

        int qr = query(0, 0, n, k, false);

        if (s.size() < 1000) {
            int ans = -pref_sm[qr + 1] + pref_sm[ql];

            int i = ql;
            while (br[i] <= qr) {
                ans += a[i] * (br[i] - i);
                i = br[i];
            }

            int j = i;

            i = qr;
            while (bl[i] >= ql) {
                ans += a[i] * (i - bl[i]);
                i = bl[i];
            }

            ans += (abs(i - j) + 1) * a[i];

            cout << ans << "\n";
            continue;
        }

        if (n > 1000) {
            int ans = min(a[ql], q[qr]) * (qr - ql + 1);

            cout << ans - (pref_sm[qr + 1] - pref_sm[ql]) << "\n";
            continue;
        }

        if (qr - qm - 1 < qm - ql) {
            int ans = -pref_sm[qr + 1] + pref_sm[ql];
            ans += ml[ql];

            for (int i = qm + 1; i <= qr; ++i) {
                for (int j = max(ql, bl[i] + 1); j <= i; ++j) {
                    ans -= min(query_mx(0, 0, n, ql, j + 1), query_mx(0, 0, n, j, i));
                    ans += min(query_mx(0, 0, n, ql, j + 1), query_mx(0, 0, n, j, i + 1));
                }
            }

            cout << ans << "\n";

            ans -= -pref_sm[qr + 1] + pref_sm[ql];

            ml[ql] = ans;
            mr[qr] = ans;
        } else {
            int ans = -pref_sm[qr + 1] + pref_sm[ql];
            ans += mr[qr];

            for (int i = qm; i >= ql; --i) {
                for (int j = max(qr, br[i] - 1); j >= i; --j) {
                    ans -= min(query_mx(0, 0, n, i + 1, j + 1), query_mx(0, 0, n, j, qr + 1));
                    ans += min(query_mx(0, 0, n, i, j + 1), query_mx(0, 0, n, j, qr + 1));
                }
            }

            cout << ans << "\n";

            ans -= -pref_sm[qr + 1] + pref_sm[ql];

            ml[ql] = ans;
            mr[qr] = ans;
        }
    }

    return 0;
}