#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 1e5;

int a[N], bl[N], br[N], pref_sm[N + 1], ml[N], mr[N], tree_mx[4 * N];

int ph[4 * N];
pair<int, int> tree[4 * N];

void init(int n, int l, int r) {
    if (r - l == 1) {
        tree[n] = {r, r};
        tree_mx[n] = a[l];
        return;
    }

    int m = (l + r) / 2;
    init(2 * n + 1, l, m);
    init(2 * n + 2, m, r);

    tree[n] = {l + 1, r};
    tree_mx[n] = max(tree_mx[2 * n + 1], tree_mx[2 * n + 2]);
}

void push(int n, int l, int r) {
    tree[n].first += ph[n];
    tree[n].second += ph[n];

    if (r - l > 1) {
        ph[2 * n + 1] += ph[n];
        ph[2 * n + 2] += ph[n];
    }

    ph[n] = 0;
}

int query(int n, int l, int r, int val, bool flag) {
    push(n, l, r);

    if (r - l == 1) return l;

    int m = (l + r) / 2;

    push(2 * n + 1, l, m);
    push(2 * n + 2, m, r);

    if (flag) {
        if (tree[2 * n + 1].first <= val && val <= tree[2 * n + 1].second) {
            return query(2 * n + 1, l, m, val, flag);
        }
        return query(2 * n + 2, m, r, val, flag);
    }

    if (tree[2 * n + 2].first <= val && val <= tree[2 * n + 2].second) {
        return query(2 * n + 2, m, r, val, flag);
    }

    return query(2 * n + 1, l, m, val, flag);
}

void update(int n, int l, int r, int ql, int qr) {
    push(n, l, r);

    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        ph[n]--;
        push(n, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(2 * n + 1, l, m, ql, qr);
    update(2 * n + 2, m, r, ql, qr);

    tree[n].first = min(tree[2 * n + 1].first, tree[2 * n + 2].first);
    tree[n].second = max(tree[2 * n + 1].second, tree[2 * n + 2].second);
}

int query_mx(int n, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return 0;
    if (ql <= l && r <= qr) return tree_mx[n];

    int m = (l + r) / 2;
    return max(query_mx(2 * n + 1, l, m, ql, qr), query_mx(2 * n + 2, m, r, ql, qr));
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    unordered_set<int> s;
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; s.insert(a[i]);
        bl[i] = -1, br[i] = n;

        pref_sm[i + 1] = pref_sm[i] + a[i];

        ml[i] = mr[i] = a[i];
    }

    vector<int> q;
    for (int i = 0; i < n; ++i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            br[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    q.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            bl[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    init(0, 0, n);

    vector<vector<int>> upl(20, vector<int>(n));
    vector<vector<int>> cl(20, vector<int>(n));
    vector<vector<int>> cr(20, vector<int>(n));
    vector<vector<int>> upr(20, vector<int>(n));

    for (int i = 0; i < 20; ++i) {
        for (int j = 0; j < n; ++j) {
            if (!i) {
                upl[i][j] = bl[j];
                cl[i][j] = a[j] * (j - bl[j]);
                upr[i][j] = br[j];
                cr[i][j] = a[j] * (br[j] - j);
            } else {
                if (upl[i - 1][j] == -1) {
                    upl[i][j] = -1;
                    cl[i][j] = cl[i - 1][j];
                } else {
                    upl[i][j] = upl[i - 1][upl[i - 1][j]];
                    cl[i][j] = cl[i - 1][j] + cl[i - 1][upl[i - 1][j]];
                }

                if (upr[i - 1][j] == n) {
                    upr[i][j] = n;
                    cr[i][j] = cr[i - 1][j];
                } else {
                    upr[i][j] = upr[i - 1][upr[i - 1][j]];
                    cr[i][j] = cr[i - 1][j] + cr[i - 1][upr[i - 1][j]];
                }
            }
        }
    }

    for (int t = 1; t < n; ++t) {
        int k; cin >> k;

        int ql = query(0, 0, n, k, true), qm = query(0, 0, n, k, false);

        update(0, 0, n, qm + 1, n);

        int qr = query(0, 0, n, k, false);
        int ans = -pref_sm[qr + 1] + pref_sm[ql];

        int i = ql, idx = 19;
        while (idx >= 0) {
            if (upr[idx][i] <= qr) {
                ans += cr[idx][i];
                i = upr[idx][i];
            }

            --idx;
        }

        int j = i;

        i = qr; idx = 19;
        while (idx >= 0) {
            if (upl[idx][i] >= ql) {
                ans += cl[idx][i];
                i = upl[idx][i];
            }

            --idx;
        }

        ans += (abs(i - j) + 1) * a[i];

        cout << ans << "\n";
    }

    return 0;
}