#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 1e5;

int a[N], bl[N], br[N], pref_sm[N + 1];

int tree[4 * N], ph[4 * N];

void init(int n, int l, int r) {
    if (r - l == 1) {
        tree[n] = r;
        return;
    }

    int m = (l + r) / 2;
    init(2 * n + 1, l, m);
    init(2 * n + 2, m, r);

    tree[n] = r;
}

void push(int n, int l, int r) {
    tree[n] += ph[n];

    if (r - l > 1) {
        ph[2 * n + 1] += ph[n];
        ph[2 * n + 2] += ph[n];
    }

    ph[n] = 0;
}

int query(int n, int l, int r, int val, bool flag) {
    push(n, l, r);

    if (r - l == 1) return tree[n];

    int m = (l + r) / 2;
    if (flag) {
        if (tree[2 * n + 1] == val) {
            return query(2 * n + 1, l, m, val, flag);
        }
        return query(2 * n + 2, m, r, val, flag);
    }

    if (tree[2 * n + 2] == val) {
        return query(2 * n + 2, m, r, val, flag);
    }

    return query(2 * n + 1, l, m, val, flag);
}

void update(int n, int l, int r, int ql, int qr) {
    push(n, l, r);

    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        ph[n]--;
        push(n, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(2 * n + 1, l, m, ql, qr);
    update(2 * n + 2, m, r, ql, qr);

    tree[n] = max(tree[2 * n + 1], tree[2 * n + 2]);
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        bl[i] = -1, br[i] = n;

        pref_sm[i + 1] = pref_sm[i] + a[i];
    }

    vector<int> q;
    for (int i = 0; i < n; ++i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            br[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    q.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            bl[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    init(0, 0, n);

    for (int i = 1; i < n; ++i) {
        int k; cin >> k;

        int ql = query(0, 0, n, k, true), qm = query(0, 0, n, k, false);

        update(0, 0, n, qm + 1, n);

        int qr = query(0, 0, n, k, false);

        cout << ql << ' ' << qr << "\n";
    }
}