#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 1e5;

int a[N], bl[N], br[N], pref_sm[N + 1], pref_mx[N + 1], pref_mx_sm[N + 1];

int ph[4 * N];
pair<int, int> tree[4 * N];

void init(int n, int l, int r) {
    if (r - l == 1) {
        tree[n] = {r, r};
        return;
    }

    int m = (l + r) / 2;
    init(2 * n + 1, l, m);
    init(2 * n + 2, m, r);

    tree[n] = {l + 1, r};
}

void push(int n, int l, int r) {
    tree[n].first += ph[n];
    tree[n].second += ph[n];

    if (r - l > 1) {
        ph[2 * n + 1] += ph[n];
        ph[2 * n + 2] += ph[n];
    }

    ph[n] = 0;
}

int query(int n, int l, int r, int val, bool flag) {
    push(n, l, r);

    if (r - l == 1) return l;

    int m = (l + r) / 2;

    push(2 * n + 1, l, m);
    push(2 * n + 2, m, r);

    if (flag) {
        if (tree[2 * n + 1].first <= val && val <= tree[2 * n + 1].second) {
            return query(2 * n + 1, l, m, val, flag);
        }
        return query(2 * n + 2, m, r, val, flag);
    }

    if (tree[2 * n + 2].first <= val && val <= tree[2 * n + 2].second) {
        return query(2 * n + 2, m, r, val, flag);
    }

    return query(2 * n + 1, l, m, val, flag);
}

void update(int n, int l, int r, int ql, int qr) {
    push(n, l, r);

    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        ph[n]--;
        push(n, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(2 * n + 1, l, m, ql, qr);
    update(2 * n + 2, m, r, ql, qr);

    tree[n].first = min(tree[2 * n + 1].first, tree[2 * n + 2].first);
    tree[n].second = max(tree[2 * n + 1].second, tree[2 * n + 2].second);
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref_sm[i + 1] = pref_sm[i] + a[i];
        pref_mx[i + 1] = max(pref_mx[i], a[i]);
        pref_mx_sm[i + 1] = pref_mx_sm[i] + pref_mx[i + 1];

        mp[{i, i}] = a[i];
    }

    vector<int> q;
    for (int i = 0; i < n; ++i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            br[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    q.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!q.empty() && a[q.back()] < a[i]) {
            bl[q.back()] = i;
            q.pop_back();
        }

        q.push_back(i);
    }

    init(0, 0, n);

    for (int t = 1; t < n; ++t) {
        int k; cin >> k;

        int i = bl[t];

        if (i == -1) {
            cout << pref_mx_sm[t + 1] - pref_sm[t + 1] << "\n";
        } else {
            int ans = pref_mx_sm[i + 1];

            ans += (t - i) * a[t];

            cout << ans - pref_sm[t + 1] << "\n";
        }
    }

    return 0;
}